# This file was auto-generated by lib/generators/tasks/generate.rb

module Slack
  module Endpoint
    module Team
      #
      # This method is used to get the access logs for users on a team.
      #
      # @option options [Object] :count
      #   Number of items to return per page.
      # @option options [Object] :page
      #   Page number of results to return.
      # @option options [Object] :before
      #   End of time range of logs to include in results (inclusive).
      # @see https://api.slack.com/methods/team.accessLogs
      # @see https://github.com/aki017/slack-api-docs/blob/master/methods/team.accessLogs.md
      # @see https://github.com/aki017/slack-api-docs/blob/master/methods/team.accessLogs.json
      def team_accessLogs(options={})
        post("team.accessLogs", options)
      end

      #
      # This method lists billable information for each user on the team. Currently this consists solely of whether the user is
      # subject to billing per Slack's Fair Billing policy.
      #
      # @option options [Object] :user
      #   A user to retrieve the billable information for. Defaults to all users.
      # @see https://api.slack.com/methods/team.billableInfo
      # @see https://github.com/aki017/slack-api-docs/blob/master/methods/team.billableInfo.md
      # @see https://github.com/aki017/slack-api-docs/blob/master/methods/team.billableInfo.json
      def team_billableInfo(options={})
        post("team.billableInfo", options)
      end

      #
      # This method provides information about your team.
      #
      # @see https://api.slack.com/methods/team.info
      # @see https://github.com/aki017/slack-api-docs/blob/master/methods/team.info.md
      # @see https://github.com/aki017/slack-api-docs/blob/master/methods/team.info.json
      def team_info(options={})
        post("team.info", options)
      end

      #
      # This method lists the integration activity logs for a team, including when integrations are added, modified and removed. This method can only be called by Admins.
      #
      # @option options [Object] :service_id
      #   Filter logs to this service. Defaults to all logs.
      # @option options [Object] :app_id
      #   Filter logs to this Slack app. Defaults to all logs.
      # @option options [Object] :user
      #   Filter logs generated by this user’s actions. Defaults to all logs.
      # @option options [Object] :change_type
      #   Filter logs with this change type. Defaults to all logs.
      # @option options [Object] :count
      #   Number of items to return per page.
      # @option options [Object] :page
      #   Page number of results to return.
      # @see https://api.slack.com/methods/team.integrationLogs
      # @see https://github.com/aki017/slack-api-docs/blob/master/methods/team.integrationLogs.md
      # @see https://github.com/aki017/slack-api-docs/blob/master/methods/team.integrationLogs.json
      def team_integrationLogs(options={})
        post("team.integrationLogs", options)
      end

      #
      # This method is used to get the profile field definitions for this team.
      #
      # @option options [Object] :visibility
      #   Filter by visibility.
      # @see https://api.slack.com/methods/team.profile.get
      # @see https://github.com/aki017/slack-api-docs/blob/master/methods/team.profile.get.md
      # @see https://github.com/aki017/slack-api-docs/blob/master/methods/team.profile.get.json
      def team_profile_get(options={})
        post("team.profile.get", options)
      end

    end
  end
end
